﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ResxCrunch.Utils
{
    /// <summary>
    /// Holds all the constants used by the application that are common to all layers
    /// </summary>
    public class Constants
    {
        /// <summary>
        /// How many days does the trial period last?
        /// </summary>
        public const int TrialPeriodDays = 30;

        /// <summary>
        /// The email address that indicates that the copy of the app is not yet registered
        /// </summary>
        public const string TrialEmailAddress = "register@resxcrunch.com";

        /// <summary>
        /// Minimum date used by the system
        /// </summary>
        public static readonly DateTime MinDate = new DateTime(1800, 1, 1);

        /// <summary>
        /// Length of the serial generated with the serial manager
        /// </summary>
        public const int SerialLength = 10;

        /// <summary>
        /// Name of the data table containing the filters
        /// </summary>
        public const string FilterTableName = "Filters";
    }
}
