﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ResxCrunch.Utils
{
    /// <summary>
    /// Data Transfer Object containing the options to copy default values
    /// </summary>
    public class CopyDefultValuesOptions
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CopyDefultValuesOptions"/> class.
        /// </summary>
        public CopyDefultValuesOptions()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CopyDefultValuesOptions"/> class.
        /// </summary>
        /// <param name="prefix">The prefix.</param>
        /// <param name="suffix">The suffix.</param>
        public CopyDefultValuesOptions(string prefix, string suffix)
        {
            this.Prefix = prefix;
            this.Suffix = suffix;
        }

        private string prefixValue = string.Empty;

        /// <summary>
        /// Gets or sets the prefix.
        /// </summary>
        /// <value>The prefix.</value>
        public string Prefix
        {
            get
            {
                return prefixValue;
            }

            set
            {
                prefixValue = value;
            }
        }

        private string suffixValue = string.Empty;

        /// <summary>
        /// Gets or sets the suffix.
        /// </summary>
        /// <value>The suffix.</value>
        public string Suffix
        {
            get
            {
                return suffixValue;
            }

            set
            {
                suffixValue = value;
            }
        }
    }
}
