﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ResxCrunch.Utils.FileData
{
    /// <summary>
    /// Resx file group data
    /// Handles multiple resx files that are located under the same dir
    /// </summary>
    public class ResxGroupData
    {
        #region Initialization
        /// <summary>
        /// Initializes a new instance of the ResxGroupData class
        /// </summary>
        /// <param name="dir">The full path to the directory containig the resx files</param>
        /// <param name="recursive">Subdirectories will be scanned also</param>
        public ResxGroupData(string dir, bool recursive)
        {
            this.Directory = dir;
            this.Recursive = recursive;
        }
        #endregion Initialization

        #region Properties
        /// <summary>
        /// Gets or sets the directory where the Resx files are located
        /// </summary>
        public string Directory { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether subdirectories should be scanned
        /// </summary>
        public bool Recursive { get; set; }
        #endregion Properties
    }
}
